package com.example.bluetooth.le;

import android.app.Activity;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;

import com.hprt.m300lib.HPRTHelper;
import com.hprt.m300lib.HPRTHelper.onReadData;
import com.hprt.m300lib.Utiltools;

public class SettingActivity extends Activity implements OnClickListener{

	private RadioGroup rg_enter;
	private RadioGroup rg_letter;
	private RadioGroup rg_scan;
	private RadioGroup rg_sound;
	private RadioGroup rg_shock;
	private RadioButton rb_enter_no;
	private RadioButton rb_enter_yes;
	private RadioButton rb_letter_big;
	private RadioButton rb_letter_originally;
	private RadioButton rb_letter_small;
	private RadioButton rb_scan_no;
	private RadioButton rb_scan_yes;
	private RadioButton rb_sound_no;
	private RadioButton rb_shock_yes;
	private RadioButton rb_shock_no;
	private RadioButton rb_sound_yes;
	private EditText ed_gapsound_time;
	private EditText ed_longsound_time;
	private EditText ed_offpower_time;
	private EditText ed_interval_time;
	private EditText ed_offscan_time;
	private EditText ed_shock_time;
	private EditText ed_shortsound_number;
	private EditText ed_shortsound_time;
	private EditText ed_sound_number;
	private Button btn_modify;
	private HPRTHelper helper;
	private SettingViewhold settingViewhold;
	private Context mContext;
	private int isShock;
	private int intveralTime;//连续扫描间隔时间

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_setting);
		mContext = getApplicationContext();
		initView();
		initData();
	}

	private void initData() {
		helper = HPRTHelper.getHPRTHelper(mContext);
		getSettingViewhold();
		Log.d("Print",HPRTHelper.bytetohex( helper.getVersion()[1]));
		if(helper.getVersion() != null && helper.getVersion().length == 2&& helper.getVersion()[1]>0){
			findViewById(R.id.layout_interval).setVisibility(View.VISIBLE);
		}else{
			findViewById(R.id.layout_interval).setVisibility(View.GONE);
		}
	}

	private void initView() {
		rg_enter = (RadioGroup) findViewById(R.id.rg_enter);
		rg_letter = (RadioGroup) findViewById(R.id.rg_letter);
		rg_scan = (RadioGroup) findViewById(R.id.rg_scan);
		rg_sound = (RadioGroup) findViewById(R.id.rg_sound);
		rg_shock = (RadioGroup) findViewById(R.id.rg_shock);
		rb_enter_no = (RadioButton) findViewById(R.id.rb_enter_no);
		rb_enter_yes = (RadioButton) findViewById(R.id.rb_enter_yes);
		rb_letter_big = (RadioButton) findViewById(R.id.rb_letter_big);
		rb_letter_originally = (RadioButton) findViewById(R.id.rb_letter_originally);
		rb_letter_small = (RadioButton) findViewById(R.id.rb_letter_small);
		rb_scan_no = (RadioButton) findViewById(R.id.rb_scan_no);
		rb_scan_yes = (RadioButton) findViewById(R.id.rb_scan_yes);
		rb_sound_no = (RadioButton) findViewById(R.id.rb_sound_no);
		rb_sound_yes = (RadioButton) findViewById(R.id.rb_sound_yes);
		rb_shock_no = (RadioButton) findViewById(R.id.rb_shock_no);
		rb_shock_yes = (RadioButton) findViewById(R.id.rb_shock_yes);
		ed_gapsound_time = (EditText) findViewById(R.id.ed_gapsound_time);
		ed_longsound_time = (EditText) findViewById(R.id.ed_longsound_time);
		ed_offpower_time = (EditText) findViewById(R.id.ed_offpower_time);
		ed_interval_time = (EditText) findViewById(R.id.ed_interval_time);
		ed_offscan_time = (EditText) findViewById(R.id.ed_offscan_time);
		ed_shock_time = (EditText) findViewById(R.id.ed_shock_time);
		ed_shortsound_number = (EditText) findViewById(R.id.ed_shortsound_number);
		ed_shortsound_time = (EditText) findViewById(R.id.ed_shortsound_time);
		ed_sound_number = (EditText) findViewById(R.id.ed_sound_number);
		btn_modify = (Button) findViewById(R.id.btn_modify);
		btn_modify.setOnClickListener(this);

	}
	private void getSettingViewhold(){
		helper.getSettingData(new onReadData() {
			
			@Override
			public void succeed(byte[] data) {
				if(data.length == 19){
					int low = data[17]<0?data[17]+256:data[17];
					int high = data[16]<0?data[16]+256:data[16];
					intveralTime = high*256+low;
					settingViewhold = new SettingViewhold(data[8], data[7], data[13], data[14], data[9], data[2], data[3],data[4],data[5],data[6],data[11], data[12], data[15], intveralTime);
				}else if(data.length == 17) {
					settingViewhold = new SettingViewhold(data[8], data[7], data[13], data[14], data[9], data[2], data[3], data[4], data[5], data[6], data[11], data[12]);
					settingViewhold.setShock(data[15]);
				}else{
					settingViewhold = new SettingViewhold(data[8], data[7], data[13], data[14], data[9], data[2], data[3], data[4], data[5], data[6], data[11], data[12]);
				}
				setLetter();
				setEnter();
				setSound();
				setScan();
				getShock();
				setEdtext();
			}
			
			@Override
			public void failure() {
				// TODO Auto-generated method stub
				Builder dialog = Util.Dialog(SettingActivity.this, "初始化","获取数据失败！！！");
				dialog.setNegativeButton("确定", new DialogInterface.OnClickListener() {
					
					@Override
					public void onClick(DialogInterface dialog, int which) {
						// TODO Auto-generated method stub
						finish();
					}
				});
				dialog.show();
			}
		});
	};
	private void setLetter(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getLetter()) {
		case 0:
			rg_letter.check(rb_letter_originally.getId());
			break;
		case 1:
			rg_letter.check(rb_letter_small.getId());
			break;
		case 2:
			rg_letter.check(rb_letter_big.getId());
			break;

		default:
			break;
		}
	}
	private void setEnter(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getEnter()) {
		case 0:
			rg_enter.check(rb_enter_no.getId());
			break;
		case 1:
			rg_enter.check(rb_enter_yes.getId());
			break;
			
		default:
			break;
		}
	}
	private void setSound(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getSound()) {
		case 0:
			rg_sound.check(rb_sound_no.getId());
			break;
		case 1:
			rg_sound.check(rb_sound_yes.getId());
			break;
			
		default:
			break;
		}
	}
	private void setScan(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getScan()) {
		case 0:
			rg_scan.check(rb_scan_no.getId());
			break;
		case 1:
			rg_scan.check(rb_scan_yes.getId());
			break;
			
		default:
			break;
		}
	}
	private void getShock(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getShock()) {
			case 0:
				rg_shock.check(rb_shock_no.getId());
				break;
			case 1:
				rg_shock.check(rb_shock_yes.getId());
				break;

			default:
				break;
		}
	}
	private void setEdtext(){
		if (settingViewhold==null) {
			return;
		}
		ed_gapsound_time.setText(settingViewhold.getGapSoundTime()<0?""+(settingViewhold.getGapSoundTime()+256):""+settingViewhold.getGapSoundTime());
		ed_longsound_time.setText(settingViewhold.getLongSoundTime()<0?""+(settingViewhold.getLongSoundTime()+256):""+settingViewhold.getLongSoundTime());
		ed_offpower_time.setText(settingViewhold.getOffPowerTime()<0?""+(settingViewhold.getOffPowerTime()+256):""+settingViewhold.getOffPowerTime());
		ed_offscan_time.setText(settingViewhold.getOffScanTime()<0?""+(settingViewhold.getOffScanTime()+256):""+settingViewhold.getOffScanTime());
		ed_shock_time.setText(settingViewhold.getShockTime()<0?""+(settingViewhold.getShockTime()+256):""+settingViewhold.getShockTime());
		ed_shortsound_number.setText(settingViewhold.getShortSoundNumber()<0?""+(settingViewhold.getShortSoundNumber()+256):""+settingViewhold.getShortSoundNumber());
		ed_shortsound_time.setText(settingViewhold.getShortSoundTime()<0?""+(settingViewhold.getShortSoundTime()+256):""+settingViewhold.getShortSoundTime());
		ed_sound_number.setText(settingViewhold.getSoundNumber()<0?""+(settingViewhold.getSoundNumber()+256):""+settingViewhold.getSoundNumber());
		ed_interval_time.setText(settingViewhold.getIntervalTime()+"");
	}
	

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch (v.getId()) {
		case R.id.btn_modify:
			modify();
			break;

		default:
			break;
		}
	}
	private void modify(){
		if (settingViewhold==null) {
			return;
		}
		switch (rg_letter.getCheckedRadioButtonId()) {
		case R.id.rb_letter_originally:
			settingViewhold.setLetter(0);
			break;
		case R.id.rb_letter_small:
			settingViewhold.setLetter(1);
			break;
		case R.id.rb_letter_big:
			settingViewhold.setLetter(2);
			break;
		default:
			break;
		}
		switch (rg_enter.getCheckedRadioButtonId()) {
		case R.id.rb_enter_no:
			settingViewhold.setEnter(0);
			break;
		case R.id.rb_enter_yes:
			settingViewhold.setEnter(1);
			break;
		default:
			break;
		}
		switch (rg_scan.getCheckedRadioButtonId()) {
		case R.id.rb_scan_no:
			settingViewhold.setScan(0);
			break;
		case R.id.rb_scan_yes:
			settingViewhold.setScan(1);
			break;
		default:
			break;
		}
		switch (rg_sound.getCheckedRadioButtonId()) {
			case R.id.rb_sound_no:
				settingViewhold.setSound(0);
				break;
			case R.id.rb_sound_yes:
				settingViewhold.setSound(1);
				break;
			default:
				break;
		}
		switch (rg_shock.getCheckedRadioButtonId()) {
			case R.id.rb_shock_no:
				settingViewhold.setShock(0);
				break;
			case R.id.rb_shock_yes:
				settingViewhold.setShock(1);
				break;
			default:
				break;
		}

		if(!Util.chackEdtextNoEmpty(mContext, ed_gapsound_time, "间隔时长为空")){
			return;
		}
		int gapSoundTime = Util.chackEdtextArea(mContext, ed_gapsound_time, 1, 5, "间隔时长超出范围");
		if (gapSoundTime==-1) {
			return;
		}
		settingViewhold.setGapSoundTime(gapSoundTime);
		
		if(!Util.chackEdtextNoEmpty(mContext, ed_longsound_time, "长滴时长为空")){
			return;
		}
		int longSoundTime = Util.chackEdtextArea(mContext, ed_longsound_time, 3, 30, "长滴时长超出范围");
		if (longSoundTime==-1) {
			return;
		}
		settingViewhold.setLongSoundTime(longSoundTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_offpower_time, "无动关机时长为空")){
			return;
		}
		int offPowerTime = Util.chackEdtextArea(mContext, ed_offpower_time, 3, 60, "无动关机时长超出范围");
		if (offPowerTime==-1) {
			return;
		}
		settingViewhold.setOffPowerTime(offPowerTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_offscan_time, "无动关闭扫描时长为空")){
			return;
		}
		int offScanTime = Util.chackEdtextArea(mContext, ed_offscan_time, 3, 60, "无动关闭扫描时长超出范围");
		if (offScanTime==-1) {
			return;
		}
		settingViewhold.setOffScanTime(offScanTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_shock_time, "震动时长为空")){
			return;
		}
		int shockTime = Util.chackEdtextArea(mContext, ed_shock_time, 3, 30, "震动时长超出范围");
		if (shockTime==-1) {
			return;
		}
		settingViewhold.setShockTime(shockTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_shortsound_number, "短滴次数为空")){
			return;
		}
		int shortSoundNumber = Util.chackEdtextArea(mContext, ed_shortsound_number, 1, 10, "短滴次数超出范围");
		if (shortSoundNumber==-1) {
			return;
		}
		settingViewhold.setShortSoundNumber(shortSoundNumber);
		if(!Util.chackEdtextNoEmpty(mContext, ed_shortsound_time, "短滴时长为空")){
			return;
		}
		int shortSoundTime = Util.chackEdtextArea(mContext, ed_shortsound_time, 1, 5, "短滴时长超出范围");
		if (shortSoundTime==-1) {
			return;
		}
		settingViewhold.setShortSoundTime(shortSoundTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_sound_number, "声音大小为空")){
			return;
		}
		int soundNumber = Util.chackEdtextArea(mContext, ed_sound_number, 1, 255, "声音大小超出范围");
		if (soundNumber==-1) {
			return;
		}
		settingViewhold.setSoundNumber(soundNumber);

		if(helper.getVersion()!=null && helper.getVersion()[1] >0) {//28以上版本才支持设置连续扫描检测时间
			intveralTime = Util.chackEdtextArea(mContext, ed_interval_time, 100, 5000, "连续扫描间隔时间大小超出范围");
			if (intveralTime == -1) {
				return;
			}
		}
		//默认1.2版本协议
		byte[] cmd_data = new byte[]{(byte) settingViewhold.getLongSoundTime(), (byte) settingViewhold.getShortSoundTime(), (byte) settingViewhold.getGapSoundTime()
				, (byte) settingViewhold.getShortSoundNumber(), (byte) settingViewhold.getShockTime(), (byte) settingViewhold.getEnter(), (byte) settingViewhold.getLetter()
				, (byte) settingViewhold.getSoundNumber(), 1, (byte) settingViewhold.getOffScanTime(), (byte) settingViewhold.getOffPowerTime(), (byte) settingViewhold.getScan()
				, (byte) settingViewhold.getSound(), (byte) settingViewhold.getShock()};

		if(helper.getVersion()!= null && helper.getVersion().length == 2 && helper.getVersion()[1]>0) {
			//1.4协议版本，28以上固件版本以上增加了间隔时间指令,增加两个字段
			byte[] intveralTimeData = new byte[]{(byte) (intveralTime / 256), (byte) (intveralTime % 256)};
			cmd_data = Utiltools.mergeData(cmd_data, intveralTimeData);
		}
		byte[] head = new byte[]{0x02, (byte)(cmd_data.length)};
		byte[] data = Utiltools.mergeData(head, cmd_data);
		int sum = Utiltools.sumByte(data);
		byte[] tmp = new byte[1];
		tmp[0] = (byte)sum;
		byte[] settingdata = Utiltools.mergeData(data, tmp);
		Log.d("Print","settingdata:"+HPRTHelper.bytetohex(settingdata));
		boolean setSetting = helper.setSetting(settingdata);

		if (setSetting) {
			Util.ToastMessage(mContext, "修改成功");
		}else {
			Util.ToastMessage(mContext, "修改失败");
		}
	}
}
