package com.example.bluetooth.le;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.TextView;

import com.hprt.m300lib.HPRTHelper;
import com.hprt.m300lib.HPRTHelper.onTemporarilySaveCount;
import com.hprt.m300lib.HPRTHelper.onUpLodeTemporarilyData;

public class TemporarilyActivity extends Activity implements OnClickListener{

	private Context mContext;
	private TextView tv_temporarily_data;
	private RadioGroup rg_tem_switch;
	private RadioButton rb_tem_open;
	private RadioButton rb_tem_close;
	private TextView tv_save_count;
	private HPRTHelper hprtHelper;
	private boolean mIsSaveOpen=true;
	private int mSavedCount=0;
	String str="";
	int num=1;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_temporarily);
		mContext = getApplicationContext();
		initView();
		initData();
	}

	private void initData() {
		hprtHelper = HPRTHelper.getHPRTHelper(mContext);
		TemSaveCount();
		rg_tem_switch.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(RadioGroup arg0, int arg1) {
				// TODO Auto-generated method stub
//				System.out.println("rg_tem_switch："+arg1);
				if(arg1==rb_tem_open.getId()){
					if(!mIsSaveOpen){
						mIsSaveOpen=true;
						hprtHelper.setTemporarilySave(1);//开启
					}
				}else{
					if(mIsSaveOpen){
						mIsSaveOpen=false;
						hprtHelper.setTemporarilySave(0);//关闭
					}
				}
			}
		});
	}

	private void TemSaveCount() {
		hprtHelper.getTemporarilySaveCount(new onTemporarilySaveCount() {
			
			@Override
			public void succeed(boolean isSvaeOpen, int savedCount, int leftCount) {
				// TODO Auto-generated method stub
				mIsSaveOpen=isSvaeOpen;
				mSavedCount=savedCount;
				if(isSvaeOpen){
					rg_tem_switch.check(rb_tem_open.getId());
				}else{
					rg_tem_switch.check(rb_tem_close.getId());
				}
				tv_save_count.setText(getString(R.string.tem_saved_number)+ savedCount+ "   "+getString(R.string.tem_remaining_number)+leftCount);
			}
			
			@Override
			public void failure() {
				// TODO Auto-generated method stub
				Builder dialog = Util.Dialog(TemporarilyActivity.this, getString(R.string.tem_error), getString(R.string.tem_data_failed));
				dialog.setPositiveButton(R.string.menu_sure, new DialogInterface.OnClickListener() {
					
					@Override
					public void onClick(DialogInterface arg0, int arg1) {
						// TODO Auto-generated method stub
						finish();
					}
				});
				dialog.show();
			}
		});
	}

	private void initView() {
		tv_temporarily_data = (TextView) findViewById(R.id.tv_temporarily_data);
		tv_temporarily_data.setMovementMethod(ScrollingMovementMethod.getInstance()) ; 
		rg_tem_switch = (RadioGroup) findViewById(R.id.rg_tem_switch);
		rb_tem_open = (RadioButton) findViewById(R.id.rb_tem_open);
		rb_tem_close = (RadioButton) findViewById(R.id.rb_tem_close);
		tv_save_count = (TextView) findViewById(R.id.tv_save_count);
		findViewById(R.id.btn_tem_uplode).setOnClickListener(this);
		findViewById(R.id.btn_tem_updata).setOnClickListener(this);
		findViewById(R.id.tv_tem_cleandata).setOnClickListener(this);
	}

	@Override
	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		switch (arg0.getId()) {
		case R.id.btn_tem_uplode:
			upLode();
			break;
		case R.id.btn_tem_updata:
			upData();
			break;
		case R.id.tv_tem_cleandata:
			Builder dialog = Util.Dialog(TemporarilyActivity.this, getString(R.string.tem_warning), getString(R.string.tem_is_clean_data));
			dialog.setPositiveButton(R.string.menu_sure, new DialogInterface.OnClickListener() {
				
				@Override
				public void onClick(DialogInterface arg0, int arg1) {
					// TODO Auto-generated method stub
					hprtHelper.cleanTemporarilySaveData();
					TemSaveCount();
				}
			});
			dialog.setNegativeButton(R.string.menu_cancel, null);
			dialog.show();
			break;

		default:
			break;
		}
	}

	private void upData() {
		// TODO Auto-generated method stub
		TemSaveCount();
		tv_temporarily_data.setText("");
	}

	private void upLode() {
		// TODO Auto-generated method stub
		if (mSavedCount==0)
			return;
		str="";
		num=1;
		final AlertDialog dialog = new AlertDialog.Builder(TemporarilyActivity.this).create();
		dialog.setTitle(R.string.tem_message);
		dialog.setMessage(getString(R.string.tem_uploading_data));
		dialog.show();
		new Thread(){
			public void run() {
				hprtHelper.upLodeTemporarilyData(new onUpLodeTemporarilyData() {
					
					@Override
					public void succeed(byte[] data,int tap) {
						// TODO Auto-generated method stub
						str=str+num+" "+Util.byteASCIIstr(data);
						num++;
						if(tap==0){
							tv_temporarily_data.post(new Runnable() {
								@Override
								public void run() {
									// TODO Auto-generated method stub
									dialog.dismiss();
									tv_temporarily_data.setText(str);
								}
							});
						}
					}
					
					@Override
					public void failure() {
						// TODO Auto-generated method stub
						
					}
				});
			};
		}.start();
		
	}
}
